<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractListAction.class.php';

/**
 * Sd_AbilityListAction
**/
class Sd_AbilityListAction extends Sd_AbstractListAction
{
    /**
     * @brief   Sd_UpdateHanlder
    **/
    protected $_mUpdateHandler = null;
    
    /**
     * &_getHandler
     * 
     * @param   void
     * 
     * @return  Sd_AbilityHandler
     * 
     * @protected
    **/
    function &_getHandler()
    {
        $handler =& $this->mAsset->getObject('handler', 'ability');
        return $handler;
    }

    /**
     * &_getFilterForm
     * 
     * @param   void
     * 
     * @return  Sd_AbilityFilterForm
     * 
     * @protected
    **/
    function &_getFilterForm()
    {
        $this->_mUpdateHandler =& $this->mAsset->getObject('handler','update');
        if(!isset($_GET['regist_time']))
        {
            $cri = new Criteria(1,1);
            $cri->addSort('update_time','desc');
            $obj =& $this->_mUpdateHandler->getObjects($cri,1);
            if(count($obj) == 1)
            {
                $_GET['regist_time'] = $obj[0]->get('update_time');
            }
        }
        
        // $filter =& new Sd_AbilityFilterForm();
        $filter =& $this->mAsset->getObject('filter', 'ability',false);
        $filter->prepare($this->_getPageNavi(), $this->_getHandler());
        
        return $filter;
    }

    /**
     * _getBaseUrl
     * 
     * @param   void
     * 
     * @return  string
     * 
     * @protected
    **/
    function _getBaseUrl()
    {
        return './index.php?action=AbilityList';
    }

    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewIndex(&$render)
    {
        $render->setTemplateName($this->mAsset->mDirname . '_ability_list.html');
        #cubson::lazy_load_array('ability', $this->mObjects);
        $render->setAttribute('objects', $this->mObjects);
        $render->setAttribute('pageNavi', $this->mFilter->mNavi);
        
        $render->setAttribute('updateHandler',$this->_mUpdateHandler);
    }
}

?>
