<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

define('SD_ENUM_TYPE_SEX','sex');
define('SD_ENUM_TYPE_ELEMENT_BASE','element_base');
define('SD_ENUM_TYPE_ELEMENT_EXT','element_ext');
define('SD_ENUM_TYPE_KIND','kind');
define('SD_ENUM_TYPE_TARGET','target');
define('SD_ENUM_TYPE_TYPE','type');
define('SD_ENUM_TYPE_DIRECTION','direction');
define('SD_ENUM_TYPE_BATTLE_RESULT','battle_result');
// define('SD_ENUM_TYPE_','');


/**
 * Sd_EnumHandler
**/
class Sd_EnumHandler extends XoopsObjectGenericHandler
{
    /**
     * @brief
    **/
    protected $_mType = array(
        SD_ENUM_TYPE_SEX,
        SD_ENUM_TYPE_ELEMENT_BASE,
        SD_ENUM_TYPE_ELEMENT_EXT,
        SD_ENUM_TYPE_KIND,
        SD_ENUM_TYPE_TARGET,
        SD_ENUM_TYPE_TYPE,
        SD_ENUM_TYPE_DIRECTION,
        SD_ENUM_TYPE_BATTLE_RESULT
    );
    
    /**
     * @brief   string{}{}
    **/
    protected $_mEnum = array();
    
    /**
     * @brief   string{}
    **/
    protected $_mElements = array();
    
    /**
     * __construct
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    public function __construct(&$db,$dirname)
    {
        foreach($this->_mType as $type)
        {
            $i = 1;
            while(defined($lang = '_MD_SD_LABEL_' . strtoupper($type) . $i))
            {
                $this->_mEnum[$type][$i] = constant($lang);
                $i++;
            }
        }
        
        $this->_setupElements();
    }
    
    /**
     * _setupElements
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function _setupElements()
    {
        $this->_mElements = array(
            -2 => _MD_SD_LABEL_ELEMENT_EMPTY,
            -1 => _MD_SD_LABEL_ELEMENT_NULL,
            12 => _MD_SD_LABEL_ELEMENT_NONE
        );
        
        foreach($this->_mEnum[SD_ENUM_TYPE_ELEMENT_BASE] as $key => $val)
        {
            $this->_mElements[$key - 1] = $val;
        }
        
        foreach($this->_mEnum[SD_ENUM_TYPE_ELEMENT_EXT] as $key => $val)
        {
            $this->_mElements[$key + 7] = $val;
        }
    }
    
    /**
     * convertToData
     * 
     * @param   Enum    $type
     * @param   string  $str
     * 
     * @return  int
    **/
    public function convertToData(/*** Enum ***/ $type,/*** string ***/ $str)
    {
        if(!isset($this->_mEnum[$type]))
        {
            return null;
        }
        
        return array_search($str,$this->_mEnum[$type]);
    }
    
    /**
     * convertToView
     * 
     * @param   Enum    $type
     * @param   int     $id
     * 
     * @return  string
    **/
    public function convertToView(/*** Enum ***/ $type,/*** int ***/ $id)
    {
        return isset($this->_mEnum[$type][$id]) ? $this->_mEnum[$type][$id] : null;
    }
    
    /**
     * convertElementToData
     * 
     * @param   string  $str
     * 
     * @return  int
    **/
    public function convertElementToData(/*** string ***/ $str)
    {
       return array_search($str,$this->_mElements);
    }
    
    /**
     * convertElement
     * 
     * @param   int $id
     * 
     * @return  string
    **/
    public function convertElement(/*** int ***/ $id)
    {
        return isset($this->_mElements[$id]) ? $this->_mElements[$id] : null;
    }
}

?>
