<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_ImageObject
**/
class Sd_ImageObject extends XoopsSimpleObject
{
    /**
     * Sd_ImageObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_ImageObject()
    {
        $this->initVar('image_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('eno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('image', XOBJ_DTYPE_STRING, '', false, 255);
        $this->initVar('image_height', XOBJ_DTYPE_INT, '', false);
        $this->initVar('image_width', XOBJ_DTYPE_INT, '', false);
        $this->initVar('image_link', XOBJ_DTYPE_STRING, '', false, 255);
        $this->initVar('update_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_ImageHandler
**/
class Sd_ImageHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_image';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'image_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_ImageObject';

    /**
     * Sd_ImageHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_ImageHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByEno
     * 
     * @param   int $eno
     * 
     * @return  Sd_ImageObject
    **/
    public function getByEno(/*** int ***/ $eno)
    {
        $cri = new Criteria('`i`.`eno`',$eno);
        $cri->setSort('update_time','desc');
        
        $ret = $this->getObjects($cri,1);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return $this->create();
    }
    
    /**
     * getObjects
     * 
     * @param   CriteriaElement $criteria
     * @param   int             $limit
     * @param   int             $offset
     * @param   bool            $isAsKey
     * 
     * @return  Sd_ImageObject[]
    **/
    function getObjects(CriteriaElement $criteria = null,/*** int ***/ $limit = null,/*** int ***/ $offset = null,/*** bool ***/ $idAsKey = false)
    {
        $ret = array();
        
        $sql = 'select `i`.`image_id` as image_id,`i`.`eno` as eno,`i`.`image` as image,`i`.`image_height` as image_height,`i`.`image_width` as image_width,`i`.`image_link` as image_link,`i`.`update_time` as update_time,`c`.`full_name` as name from `' . $this->mTable . '` as i left outer join `' . $this->db->prefix('sd_char') . '` as c on `i`.`eno` = `c`.`eno`';
        
        if($criteria instanceof CriteriaElement)
        {
            if(trim($where = $this->_makeCriteria4sql($criteria)) != null)
            {
                $sql .= ' where ' . $where;
            }
            
            $sorts = array();
            foreach($criteria->getSorts() as $sort)
            {
                $sorts[] = '`' . $sort['sort'] . '`' . $sort['order'];
            }
            
            if(count($sorts) > 0)
            {
                $sql .= ' order by ' . implode(',',$sorts);
            }
            
            if($limit === null)
            {
                $limit = $criteria->getLimit();
            }
            
            if($offset === null)
            {
                $offset = $criteria->getStart();
            }
        }
        else
        {
            if($limit === null)
            {
                $limit = 0;
            }
            
            if($offset === null)
            {
                $offset = 0;
            }
        }
        
        if($res = $this->db->query($sql,$limit,$offset))
        {
            while($row = $this->db->fetchArray($res))
            {
                $obj =& $this->create(false);
                $obj->initVar('name', XOBJ_DTYPE_STRING, '', false, 255);
                $obj->assignVars($row);
                
                if($idAsKey)
                {
                    $ret[$obj->get($this->mPrimary)] =& $obj;
                }
                else
                {
                    $ret[] =& $obj;
                }
                
                unset($obj);
            }
        }
        
        return $ret;
    }
    
    /**
     * getCount
     * 
     * @param   CritieriaElement    $criteria
     * 
     * @return  int
    **/
    public function getCount(CriteriaElement $criteria = null)
    {
        $sql = 'select count(*) c from `' . $this->mTable . '` as i';
        
        if($criteria instanceof CriteriaElement && ($where = $this->_makeCriteria4sql($criteria)) != null)
        {
            $sql .= ' where ' . $where;
        }
        
        return $this->_getCount($sql);
    }
}

?>
