<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Learned_skillObject
**/
class Sd_Learned_skillObject extends XoopsSimpleObject
{
    /**
     * Sd_Learned_skillObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Learned_skillObject()
    {
        $this->initVar('eno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('skill_id', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 Sd_LearnedSkillObject
**/
class Sd_LearnedSkillObject extends XoopsSimpleObject
{
    /**
     * Sd_LearningSkillObject
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function Sd_LearnedSkillObject()
    {
        $this->initVar('eno',XOBJ_DTYPE_INT,'',false);
        $this->initVar('name',XOBJ_DTYPE_STRING,'',false);
    }
}


/**
 * Sd_Learned_skillHandler
**/
class Sd_Learned_skillHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_learned_skill';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'eno';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Learned_skillObject';

    /**
     * @brief   string
    **/
    protected $_mCharTable = '{dirname}_char';

    /**
     * @brief   string
    **/
    protected $_mNameTable = '{dirname}_skill';

    /**
     * Sd_Learned_skillHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Learned_skillHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
        
        $this->_mCharTable = $this->db->prefix(str_replace('{dirname}',$dirname,$this->_mCharTable));
        $this->_mNameTable = $this->db->prefix(str_replace('{dirname}',$dirname,$this->_mNameTable));
    }
    
    /**
     * escapeString
     * 
     * @param   string  $str
     * 
     * @return  string
    **/
    protected function escapeString(/*** string ***/ $str)
    {
        return mysql_real_escape_string($str,$this->db->conn);
    }
    
    /**
     * getByUnique
     * 
     * @param   int $eno
     * @param   int $skillId
     * 
     * @return  Sd_Learned_abilityObject
    **/
    public function getByUnique(/*** int ***/ $eno,/*** int ***/ $skillId)
    {
        $cri = new CriteriaCompo(new Criteria('eno',$eno));
        $cri->add(new Criteria('skill_id',$skillId));
        
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
    
    /**
     * &getLearningChars
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  Sd_LearnedSkillObject[]
    **/
    public function &getLearningChars(CriteriaElement $cri)
    {
        $ret = array();
        $sql = 'select distinct `c`.`eno` as eno,`c`.`full_name` as name from `' . $this->_mCharTable . '` as c ';
        $where = '';
        
        for($i = 0;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $sql .= XCube_Utils::formatString(
                'left join `{0}` as w{1} on `c`.`eno` = `w{1}`.`eno` '
              . 'left join `{2}` as n{1} on `n{1}`.`skill_id` = `w{1}`.`skill_id` ',
                $this->mTable,$i,$this->_mNameTable
            );
            $where .= XCube_Utils::formatString(
                "{0}`n{1}`.`skill_name` like '{2}%' ",
                ($i > 0 ? 'and ' : ''),$i,$this->escapeString($c->getValue())
            );
        }
        
        $sql .= 'where ' . $where . 'order by `c`.`eno` asc';
        
        if($res = $this->db->query($sql,$cri->getLimit(),$cri->getStart()))
        {
            while($row = $this->db->fetchArray($res))
            {
                $obj = new Sd_LearnedSkillObject();
                $obj->setVars($row);
                $ret[] =& $obj;
                unset($obj);
            }
        }
        
        return $ret;
    }
    
    /**
     * getLearningCharsCount
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  int
    **/
    public function getLearningCharsCount(CriteriaElement $cri)
    {
        $c = $cri->getChildElement(0);
        $sql = XCube_Utils::formatString(
            'select count(distinct `w0`.`eno`) as c from `{0}` as w0 '
          . 'left join `{1}` as n0 on `n0`.`skill_id` = `w0`.`skill_id` ',
            $this->mTable,$this->_mNameTable
        );
        $where = "`n0`.`skill_name` like '" . $this->escapeString($c->getValue()) . "%' ";
        
        for($i = 1;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $sql .= XCube_Utils::formatString(
                'left join `{0}` as w{1} on `w0`.`eno` = `w{1}`.`eno` '
              . 'left join `{2}` as n{1} on `n{1}`.`skill_id` = `w{1}`.`skill_id` ',
                $this->mTable,$i,$this->_mNameTable
            );
            $where .= XCube_Utils::formatString(
                "and `n{0}`.`skill_name` like '{1}%' ",
                $i,$this->escapeString($c->getValue())
            );
        }
        
        if($res = $this->db->query($sql . 'where ' . $where))
        {
            $row = $this->db->fetchArray($res);
            
            return $row['c'];
        }
        
        return null;
    }
}

?>
