<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_PartyObject
**/
class Sd_PartyObject extends XoopsSimpleObject
{
    /**
     * Sd_PartyObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_PartyObject()
    {
        $this->initVar('pno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('party_name', XOBJ_DTYPE_STRING, '', false, 255);
        $this->initVar('x', XOBJ_DTYPE_INT, '', false);
        $this->initVar('y', XOBJ_DTYPE_INT, '', false);
        $this->initVar('turn', XOBJ_DTYPE_INT, '', false);
        $this->initVar('result', XOBJ_DTYPE_INT, '', false);
        $this->initVar('get_exp', XOBJ_DTYPE_INT, '', false);
        $this->initVar('get_money', XOBJ_DTYPE_INT, '', false);
    }
    
    /**
     * refleshResult
     * 
     * @param   string  $name
     * 
     * @return  void
    **/
    public function refleshResult(/*** string ***/ $name)
    {
        $this->setVars(
            array(
                'party_name' => $name,
                'turn'       => 0,
                'result'     => 1,
                'get_exp'    => 0,
                'get_money'  => 0
            )
        );
    }
    
    /**
     * setPoint
     * 
     * @param   int     $x
     * @param   int     $y
     * 
     * @return  void
    **/
    public function setPoint($x = 0,$y = 0)
    {
        $this->setVars(
            array(
                'x' => $x,
                'y' => $y
            )
        );
    }
    
    /**
     * moveByDirection
     * 
     * @param   Enum    $direction
     * 
     * @return  void
    **/
    public function moveByDirection(/*** Enum ***/ $direction)
    {
        switch($direction)
        {
            case _MD_SD_LABEL_DIRECTION1:
            case _MD_SD_LABEL_DIRECTION4:
            case _MD_SD_LABEL_DIRECTION6:
                $this->set('x',$this->get('x') - 1);
                break;
            case _MD_SD_LABEL_DIRECTION3:
            case _MD_SD_LABEL_DIRECTION5:
            case _MD_SD_LABEL_DIRECTION8:
                $this->set('x',$this->get('x') + 1);
                break;
            default:
                break;
        }
        
        switch($direction)
        {
            case _MD_SD_LABEL_DIRECTION1:
            case _MD_SD_LABEL_DIRECTION2:
            case _MD_SD_LABEL_DIRECTION3:
                $this->set('y',$this->get('y') - 1);
                break;
            case _MD_SD_LABEL_DIRECTION6:
            case _MD_SD_LABEL_DIRECTION7:
            case _MD_SD_LABEL_DIRECTION8:
                $this->set('y',$this->get('y') + 1);
                break;
            default:
                break;
        }
    }
}

/**
 * Sd_PartyHandler
**/
class Sd_PartyHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_party';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'pno';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_PartyObject';

    /**
     * Sd_PartyHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_PartyHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
}

?>
