<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_ENEMY_SORT_KEY_ENEMY_ID', 1);
define('SD_ENEMY_SORT_KEY_ENEMY_NAME', 2);
define('SD_ENEMY_SORT_KEY_ATTACK_KIND', 3);
define('SD_ENEMY_SORT_KEY_POSITION', 4);
define('SD_ENEMY_SORT_KEY_REGIST_TIME', 5);
define('SD_ENEMY_SORT_KEY_DEFAULT', SD_ENEMY_SORT_KEY_ENEMY_ID);

/**
 * Sd_EnemyFilterForm
**/
class Sd_EnemyFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_ENEMY_SORT_KEY_ENEMY_ID => 'enemy_id',
        SD_ENEMY_SORT_KEY_ENEMY_NAME => 'enemy_name',
        SD_ENEMY_SORT_KEY_ATTACK_KIND => 'attack_kind',
        SD_ENEMY_SORT_KEY_POSITION => 'position',
        SD_ENEMY_SORT_KEY_REGIST_TIME => 'regist_time'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_ENEMY_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('enemy_id')) !== null) {
            $this->mNavi->addExtra('enemy_id', $value);
            $this->_mCriteria->add(new Criteria('enemy_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('enemy_name')) !== null) {
            $this->mNavi->addExtra('enemy_name', $value);
            $this->_mCriteria->add(new Criteria('enemy_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('attack_kind')) !== null) {
            $this->mNavi->addExtra('attack_kind', $value);
            $this->_mCriteria->add(new Criteria('attack_kind', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('position')) !== null) {
            $this->mNavi->addExtra('position', $value);
            $this->_mCriteria->add(new Criteria('position', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) !== null) {
            $this->mNavi->addExtra('regist_time', $value);
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
    
        $this->_mCriteria->addSort('enemy_name', 'asc');
    }
}

?>
