<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_IMAGE_SORT_KEY_IMAGE_ID', 1);
define('SD_IMAGE_SORT_KEY_ENO', 2);
define('SD_IMAGE_SORT_KEY_IMAGE', 3);
define('SD_IMAGE_SORT_KEY_IMAGE_HEIGHT', 4);
define('SD_IMAGE_SORT_KEY_IMAGE_WIDTH', 5);
define('SD_IMAGE_SORT_KEY_IMAGE_LINK', 6);
define('SD_IMAGE_SORT_KEY_UPDATE_TIME', 7);
define('SD_IMAGE_SORT_KEY_DEFAULT', SD_IMAGE_SORT_KEY_IMAGE_ID);

/**
 * Sd_ImageFilterForm
**/
class Sd_ImageFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_IMAGE_SORT_KEY_IMAGE_ID => 'image_id',
        SD_IMAGE_SORT_KEY_ENO => 'eno',
        SD_IMAGE_SORT_KEY_IMAGE => 'image',
        SD_IMAGE_SORT_KEY_IMAGE_HEIGHT => 'image_height',
        SD_IMAGE_SORT_KEY_IMAGE_WIDTH => 'image_width',
        SD_IMAGE_SORT_KEY_IMAGE_LINK => 'image_link',
        SD_IMAGE_SORT_KEY_UPDATE_TIME => 'update_time'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_IMAGE_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('eno')) != null) {
            $ext = array();
            $cri = new CriteriaCompo();
            foreach(explode(' ',mb_convert_kana($value,'as')) as $v)
            {
                if(ctype_digit($v))
                {
                    $ext[] = $v;
                    $cri->add(new Criteria('`i`.`eno`',$v),'or');
                }
            }
            $this->mNavi->addExtra('eno', implode(' ',$ext));
            $this->_mCriteria->add($cri);
        }
        else if (($value = intval($root->mContext->mRequest->getRequest('update_time'))) > 0) {
            $this->mNavi->addExtra('update_time', $value);
            $this->_mCriteria->add(new Criteria('update_time', $value));
        }
    
        if($this->_mCriteria->hasChildElements())
        {
            if (($value = $root->mContext->mRequest->getRequest('image')) != null) {
                $this->mNavi->addExtra('image', $value);
                $this->_mCriteria->add(new Criteria('image','',($value == 'on' ? '>' : '=')));
            }
        
            if (($value = $root->mContext->mRequest->getRequest('image_link')) != null) {
                $this->mNavi->addExtra('image_link', $value);
                $this->_mCriteria->add(new Criteria('image_link','',($value == 'on' ? '>' : '=')));
            }
        }
        else
        {
            $this->_mCriteria->add(new Criteria(1,2));
        }
    
        $this->_mCriteria->addSort($this->mSortKeys[SD_IMAGE_SORT_KEY_ENO],'asc');
        $this->_mCriteria->addSort($this->mSortKeys[SD_IMAGE_SORT_KEY_UPDATE_TIME],'desc');
        
        if(($value = intval($root->mContext->mRequest->getRequest($this->mNavi->getPerpageKey()))) > 0)
        {
            $this->mNavi->setPerpage($value);
        }
    
        $this->mNavi->addExtra('show_image',($root->mContext->mRequest->getRequest('show_image') == 'on' ? 'on' : 'off'));
    }
}

?>
