<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_ITEM_SORT_KEY_ITEM_ID', 1);
define('SD_ITEM_SORT_KEY_ITEM_NAME', 2);
define('SD_ITEM_SORT_KEY_KIND', 3);
define('SD_ITEM_SORT_KEY_LV', 4);
define('SD_ITEM_SORT_KEY_ELEMENT', 5);
define('SD_ITEM_SORT_KEY_AT', 6);
define('SD_ITEM_SORT_KEY_DF', 7);
define('SD_ITEM_SORT_KEY_MAT', 8);
define('SD_ITEM_SORT_KEY_MDF', 9);
define('SD_ITEM_SORT_KEY_RANGE', 10);
define('SD_ITEM_SORT_KEY_REGIST_TIME', 11);
define('SD_ITEM_SORT_KEY_DEFAULT', SD_ITEM_SORT_KEY_ITEM_ID);

/**
 * Sd_ItemFilterForm
**/
class Sd_ItemFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_ITEM_SORT_KEY_ITEM_ID => 'item_id',
        SD_ITEM_SORT_KEY_ITEM_NAME => 'item_name',
        SD_ITEM_SORT_KEY_KIND => 'kind',
        SD_ITEM_SORT_KEY_LV => 'lv',
        SD_ITEM_SORT_KEY_ELEMENT => 'element',
        SD_ITEM_SORT_KEY_AT => 'at',
        SD_ITEM_SORT_KEY_DF => 'df',
        SD_ITEM_SORT_KEY_MAT => 'mat',
        SD_ITEM_SORT_KEY_MDF => 'mdf',
        SD_ITEM_SORT_KEY_RANGE => 'range',
        SD_ITEM_SORT_KEY_REGIST_TIME => 'regist_time'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_ITEM_SORT_KEY_DEFAULT;
    }

    /**
     * getTotalItems
     * 
     * @param   int  &$total
     * 
     * @return  void
     * 
     * @protected
    **/
    function getTotalItems(&$total)
    {
        $total = $this->_mHandler->getItemListCount($this->getCriteria());
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('item_id')) !== null) {
            $this->mNavi->addExtra('item_id', $value);
            $this->_mCriteria->add(new Criteria('item_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('item_name')) !== null) {
            $this->mNavi->addExtra('item_name', $value);
            $this->_mCriteria->add(new Criteria('item_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('kind')) !== null) {
            $this->mNavi->addExtra('kind', $value);
            $this->_mCriteria->add(new Criteria('kind', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('lv')) !== null) {
            $this->mNavi->addExtra('lv', $value);
            $this->_mCriteria->add(new Criteria('lv', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('element')) !== null) {
            $this->mNavi->addExtra('element', $value);
            $this->_mCriteria->add(new Criteria('element', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('at')) !== null) {
            $this->mNavi->addExtra('at', $value);
            $this->_mCriteria->add(new Criteria('at', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('df')) !== null) {
            $this->mNavi->addExtra('df', $value);
            $this->_mCriteria->add(new Criteria('df', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('mat')) !== null) {
            $this->mNavi->addExtra('mat', $value);
            $this->_mCriteria->add(new Criteria('mat', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('mdf')) !== null) {
            $this->mNavi->addExtra('mdf', $value);
            $this->_mCriteria->add(new Criteria('mdf', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('range')) !== null) {
            $this->mNavi->addExtra('range', $value);
            $this->_mCriteria->add(new Criteria('range', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) != null) {
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
        $this->mNavi->addExtra('regist_time', $value);
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
